//Scrivere un programma C che legge da tastiera una matrice di NxM 
//elementi float e ne stampa la versione trasposta; scrivere la 
//funzione che prende una matrice e ne genera la trasposta.
//N e M sono introdotti da tastiera
//
//SUGGERIMENTO: la trasposta di una matrice A NxM e' 
//una matrice B MxN avente a(i,j)=b(j,i)

#include <stdio.h>
#include <stdlib.h>

void trasponi(float *sorg, float *dest,  int righesorg, int colonnesorg);

int main(int argc, char *argv[])
{
  int i,j,righe,colonne;
  float *matrA,*matrB;

  printf("\nInserire RIGHE:\n");
  scanf("%d", &righe);
  printf("\nInserire COLONNE:\n");
  scanf("%d", &colonne);

  matrA=(float*)malloc(sizeof(float)*righe*colonne);
  matrB=(float*)malloc(sizeof(float)*colonne*righe);

  if((matrA==NULL)||(matrB==NULL))
  {
    fprintf(stderr, "Out of memory!\n");
    return 1;
  }

  for(i=0; i<righe; i++)
  {
    for(j=0; j<colonne; j++)
    {
      printf("\nElem (%d, %d):  ", i, j);
      scanf("%f", &matrA[i*colonne+j]);
    }
  }

  trasponi(matrA, matrB, righe, colonne);

  printf("\n\nMatrice sorgente:\n\n");

  for(i=0; i<righe; i++)
  {
    for(j=0; j<colonne; j++)
    {
      printf("%f ", matrA[i*colonne+j]);
    }
    printf("\n");
  }

  printf("\n\nMatrice destinazione:\n\n");

  for(i=0; i<colonne; i++)
  {
    for(j=0; j<righe; j++)
    {
      printf("%f ", matrB[i*righe+j]);
    }
    printf("\n");
  }

  free(matrA);
  free(matrB);

  return 0;
}

void trasponi(float *sorg, float *dest,  int righesorg, int colonnesorg)
{
  int i, j;

  for(i=0; i<righesorg; i++)
  {
      for(j=0; j<colonnesorg; j++)
      {
        dest[j*righesorg+i] = sorg[i*colonnesorg+j];
      }
  }
}


